]> git.ipfire.org Git - ipfire-2.x.git/blob - make.sh
make.sh: Move ccache's temp directory into /tmp
[ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007-2020 IPFire Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 # If you update the version don't forget to update backupiso and add it to core update
28 VERSION="2.25" # Version number
29 CORE="143" # Core Level (Filename)
30 SLOGAN="www.ipfire.org" # Software slogan
31 CONFIG_ROOT=/var/ipfire # Configuration rootdir
32 NICE=10 # Nice level
33 MAX_RETRIES=1 # prefetch/check loop
34 BUILD_IMAGES=1 # Flash and Xen Downloader
35 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
36
37 # Information from Git
38 GIT_BRANCH="$(git rev-parse --abbrev-ref HEAD)" # Git Branch
39 GIT_TAG="$(git tag | tail -1)" # Git Tag
40 GIT_LASTCOMMIT="$(git rev-parse --verify HEAD)" # Last commit
41
42 TOOLCHAINVER=20200108
43
44 ###############################################################################
45 #
46 # Beautifying variables & presentation & input output interface
47 #
48 ###############################################################################
49
50 # Remember if the shell is interactive or not
51 if [ -t 0 ] && [ -t 1 ]; then
52 INTERACTIVE=true
53 else
54 INTERACTIVE=false
55 fi
56
57 # Sets or adjusts pretty formatting variables
58 resize_terminal() {
59 ## Screen Dimentions
60 # Find current screen size
61 COLUMNS=$(tput cols)
62
63 # When using remote connections, such as a serial port, stty size returns 0
64 if ! ${INTERACTIVE} || [ "${COLUMNS}" = "0" ]; then
65 COLUMNS=80
66 fi
67
68 # Measurements for positioning result messages
69 OPTIONS_WIDTH=20
70 TIME_WIDTH=12
71 STATUS_WIDTH=8
72 NAME_WIDTH=$(( COLUMNS - OPTIONS_WIDTH - TIME_WIDTH - STATUS_WIDTH ))
73 LINE_WIDTH=$(( COLUMNS - STATUS_WIDTH ))
74
75 TIME_COL=$(( NAME_WIDTH + OPTIONS_WIDTH ))
76 STATUS_COL=$(( TIME_COL + TIME_WIDTH ))
77 }
78
79 # Initially setup terminal
80 resize_terminal
81
82 # Call resize_terminal when terminal is being resized
83 trap "resize_terminal" WINCH
84
85 # Define color for messages
86 BOLD="\\033[1;39m"
87 DONE="\\033[1;32m"
88 SKIP="\\033[1;34m"
89 WARN="\\033[1;35m"
90 FAIL="\\033[1;31m"
91 NORMAL="\\033[0;39m"
92
93 # New architecture variables
94 HOST_ARCH="$(uname -m)"
95
96 PWD=$(pwd)
97 BASENAME=$(basename $0)
98
99 # Debian specific settings
100 if [ ! -e /etc/debian_version ]; then
101 FULLPATH=`which $0`
102 else
103 if [ -x /usr/bin/realpath ]; then
104 FULLPATH=`/usr/bin/realpath $0`
105 else
106 echo "ERROR: Need to do apt-get install realpath"
107 exit 1
108 fi
109 fi
110
111 # This is the directory where make.sh is in
112 export BASEDIR=$(echo $FULLPATH | sed "s/\/$BASENAME//g")
113
114 LOGFILE=$BASEDIR/log/_build.preparation.log
115 export LOGFILE
116 DIR_CHK=$BASEDIR/cache/check
117 mkdir $BASEDIR/log/ 2>/dev/null
118
119 system_processors() {
120 getconf _NPROCESSORS_ONLN 2>/dev/null || echo "1"
121 }
122
123 system_memory() {
124 local key val unit
125
126 while read -r key val unit; do
127 case "${key}" in
128 MemTotal:*)
129 # Convert to MB
130 echo "$(( ${val} / 1024 ))"
131 break
132 ;;
133 esac
134 done < /proc/meminfo
135 }
136
137 configure_build() {
138 local build_arch="${1}"
139
140 if [ "${build_arch}" = "default" ]; then
141 build_arch="$(configure_build_guess)"
142 fi
143
144 case "${build_arch}" in
145 x86_64)
146 BUILDTARGET="${build_arch}-unknown-linux-gnu"
147 CROSSTARGET="${build_arch}-cross-linux-gnu"
148 BUILD_PLATFORM="x86"
149 CFLAGS_ARCH="-m64 -mindirect-branch=thunk -mfunction-return=thunk -mtune=generic"
150 ;;
151
152 i586)
153 BUILDTARGET="${build_arch}-pc-linux-gnu"
154 CROSSTARGET="${build_arch}-cross-linux-gnu"
155 BUILD_PLATFORM="x86"
156 CFLAGS_ARCH="-march=i586 -mindirect-branch=thunk -mfunction-return=thunk -mtune=generic -fomit-frame-pointer"
157 ;;
158
159 aarch64)
160 BUILDTARGET="${build_arch}-unknown-linux-gnu"
161 CROSSTARGET="${build_arch}-cross-linux-gnu"
162 BUILD_PLATFORM="arm"
163 CFLAGS_ARCH=""
164 ;;
165
166 armv7hl)
167 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
168 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
169 BUILD_PLATFORM="arm"
170 CFLAGS_ARCH="-march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
171 ;;
172
173 armv5tel)
174 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
175 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
176 BUILD_PLATFORM="arm"
177 CFLAGS_ARCH="-march=armv5te -mfloat-abi=soft -fomit-frame-pointer"
178 RUSTFLAGS="-Ccodegen-units=1"
179 ;;
180
181 *)
182 exiterror "Cannot build for architure ${build_arch}"
183 ;;
184 esac
185
186 # Check if the QEMU helper is available if needed.
187 if qemu_is_required "${build_arch}"; then
188 local qemu_build_helper="$(qemu_find_build_helper_name "${build_arch}")"
189
190 if [ -n "${qemu_build_helper}" ]; then
191 QEMU_TARGET_HELPER="${qemu_build_helper}"
192 else
193 exiterror "Could not find a binfmt_misc helper entry for ${build_arch}"
194 fi
195 fi
196
197 BUILD_ARCH="${build_arch}"
198 TOOLS_DIR="/tools_${BUILD_ARCH}"
199
200 # Enables hardening
201 HARDENING_CFLAGS="-Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong"
202
203 CFLAGS="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
204 CXXFLAGS="${CFLAGS}"
205
206 # Determine parallelism
207 # We assume that each process consumes about
208 # 128MB of memory. Therefore we find out how
209 # many processes fit into memory.
210 local mem_max=$(( ${SYSTEM_MEMORY} / 128 ))
211 local cpu_max=$(( ${SYSTEM_PROCESSORS} + 1 ))
212
213 local parallelism
214 if [ ${mem_max} -lt ${cpu_max} ]; then
215 parallelism=${mem_max}
216 else
217 parallelism=${cpu_max}
218 fi
219
220 # Use this as default PARALLELISM
221 DEFAULT_PARALLELISM="${parallelism}"
222
223 # Compression parameters
224 # We use mode 8 for reasonable memory usage when decompressing
225 # but with overall good compression
226 XZ_OPT="-8"
227
228 # We try to use as many cores as possible
229 XZ_OPT="${XZ_OPT} -T0"
230
231 # We need to limit memory because XZ uses too much when running
232 # in parallel and it isn't very smart in limiting itself.
233 # We allow XZ to use up to 70% of all system memory.
234 local xz_memory=$(( SYSTEM_MEMORY * 7 / 10 ))
235
236 # XZ memory cannot be larger than 2GB on 32 bit systems
237 case "${build_arch}" in
238 i*86|armv*)
239 if [ ${xz_memory} -gt 2048 ]; then
240 xz_memory=2048
241 fi
242 ;;
243 esac
244
245 XZ_OPT="${XZ_OPT} --memory=${xz_memory}MiB"
246 }
247
248 configure_build_guess() {
249 case "${HOST_ARCH}" in
250 x86_64)
251 echo "x86_64"
252 ;;
253 i?86)
254 echo "i586"
255 ;;
256
257 aarch64)
258 echo "aarch64"
259 ;;
260
261 armv7*|armv6*|armv5*)
262 echo "armv5tel"
263 ;;
264
265 *)
266 exiterror "Cannot guess build architecture"
267 ;;
268 esac
269 }
270
271 stdumount() {
272 umount $BASEDIR/build/sys 2>/dev/null;
273 umount $BASEDIR/build/dev/shm 2>/dev/null;
274 umount $BASEDIR/build/dev/pts 2>/dev/null;
275 umount $BASEDIR/build/dev 2>/dev/null;
276 umount $BASEDIR/build/proc 2>/dev/null;
277 umount $BASEDIR/build/install/mnt 2>/dev/null;
278 umount $BASEDIR/build/usr/src/cache 2>/dev/null;
279 umount $BASEDIR/build/usr/src/ccache 2>/dev/null;
280 umount $BASEDIR/build/usr/src/config 2>/dev/null;
281 umount $BASEDIR/build/usr/src/doc 2>/dev/null;
282 umount $BASEDIR/build/usr/src/html 2>/dev/null;
283 umount $BASEDIR/build/usr/src/langs 2>/dev/null;
284 umount $BASEDIR/build/usr/src/lfs 2>/dev/null;
285 umount $BASEDIR/build/usr/src/log 2>/dev/null;
286 umount $BASEDIR/build/usr/src/src 2>/dev/null;
287 umount $BASEDIR/build/usr/src 2>/dev/null;
288 }
289
290 now() {
291 date -u "+%s"
292 }
293
294 format_runtime() {
295 local seconds=${1}
296
297 if [ ${seconds} -ge 3600 ]; then
298 printf "%d:%02d:%02d\n" \
299 "$(( seconds / 3600 ))" \
300 "$(( seconds % 3600 / 60 ))" \
301 "$(( seconds % 3600 % 60 ))"
302 elif [ ${seconds} -ge 60 ]; then
303 printf "%d:%02d\n" \
304 "$(( seconds / 60 ))" \
305 "$(( seconds % 60 ))"
306 else
307 printf "%d\n" "${seconds}"
308 fi
309 }
310
311 print_line() {
312 local line="$@"
313
314 printf "%-${LINE_WIDTH}s" "${line}"
315 }
316
317 _print_line() {
318 local status="${1}"
319 shift
320
321 if ${INTERACTIVE}; then
322 printf "${!status}"
323 fi
324
325 print_line "$@"
326
327 if ${INTERACTIVE}; then
328 printf "${NORMAL}"
329 fi
330 }
331
332 print_headline() {
333 _print_line BOLD "$@"
334 }
335
336 print_error() {
337 _print_line FAIL "$@"
338 }
339
340 print_package() {
341 local name="${1}"
342 shift
343
344 local version="$(grep -E "^VER |^VER=|^VER " $BASEDIR/lfs/${name} | awk '{ print $3 }')"
345 local options="$@"
346
347 local string="${name}"
348 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
349 string="${string} (${version})"
350 fi
351
352 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
353 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
354 }
355
356 print_runtime() {
357 local runtime=$(format_runtime $@)
358
359 if ${INTERACTIVE}; then
360 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
361 else
362 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
363 fi
364 }
365
366 print_status() {
367 local status="${1}"
368
369 local color="${!status}"
370
371 if ${INTERACTIVE}; then
372 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
373 else
374 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
375 fi
376 }
377
378 print_build_stage() {
379 print_headline "$@"
380
381 # end line
382 printf "\n"
383 }
384
385 print_build_summary() {
386 local runtime=$(format_runtime $@)
387
388 print_line "*** Build finished in ${runtime}"
389 print_status DONE
390 }
391
392 exiterror() {
393 stdumount
394 for i in `seq 0 7`; do
395 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
396 losetup -d /dev/loop${i} 2>/dev/null
397 fi;
398 done
399
400 # Dump logfile
401 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
402 echo # empty line
403
404 local line
405 while read -r line; do
406 echo " ${line}"
407 done <<< "$(tail -n30 ${LOGFILE})"
408 fi
409
410 echo # empty line
411
412 local line
413 for line in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
414 print_error "${line}"
415 print_status FAIL
416 done
417
418 exit 1
419 }
420
421 prepareenv() {
422 # Are we running the right shell?
423 if [ -z "${BASH}" ]; then
424 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
425 fi
426
427 if [ -z "${BASH_VERSION}" ]; then
428 exiterror "Not running BASH shell."
429 fi
430
431 # Trap on emergency exit
432 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
433
434 # Resetting our nice level
435 if ! renice ${NICE} $$ >/dev/null; then
436 exiterror "Failed to set nice level to ${NICE}"
437 fi
438
439 # Checking if running as root user
440 if [ $(id -u) -ne 0 ]; then
441 exiterror "root privileges required for building"
442 fi
443
444 # Checking for necessary temporary space
445 print_line "Checking for necessary space on disk $BASE_DEV"
446 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
447 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
448 if (( 2048000 > $BASE_ASPACE )); then
449 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
450 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
451 print_status FAIL
452 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
453 fi
454 else
455 print_status DONE
456 fi
457
458 # Set umask
459 umask 022
460
461 # Set LFS Directory
462 LFS=$BASEDIR/build
463
464 # Setup environment
465 set +h
466 LC_ALL=POSIX
467 export LFS LC_ALL CFLAGS CXXFLAGS DEFAULT_PARALLELISM RUSTFLAGS
468 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
469
470 # Make some extra directories
471 mkdir -p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev/null
472 mkdir -p $BASEDIR/build/{etc,usr/src} 2>/dev/null
473 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
474 mkdir -p $BASEDIR/{cache,ccache/${BUILD_ARCH}} 2>/dev/null
475
476 if [ "${ENABLE_RAMDISK}" = "on" ]; then
477 mkdir -p $BASEDIR/build/usr/src
478 mount -t tmpfs tmpfs -o size=4G,nr_inodes=1M,mode=1777 $BASEDIR/build/usr/src
479
480 mkdir -p ${BASEDIR}/build/tmp
481 mount -t tmpfs tmpfs -o size=4G,nr_inodes=1M,mode=1777 ${BASEDIR}/build/tmp
482 fi
483
484 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
485
486 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
487 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
488
489 # Make all sources and proc available under lfs build
490 mount --bind /dev $BASEDIR/build/dev
491 mount --bind /dev/pts $BASEDIR/build/dev/pts
492 mount --bind /dev/shm $BASEDIR/build/dev/shm
493 mount --bind /proc $BASEDIR/build/proc
494 mount --bind /sys $BASEDIR/build/sys
495 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
496 mount --bind $BASEDIR/ccache/${BUILD_ARCH} $BASEDIR/build/usr/src/ccache
497 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
498 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
499 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
500 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
501 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
502 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
503 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
504
505 # Run LFS static binary creation scripts one by one
506 export CCACHE_DIR=$BASEDIR/ccache
507 export CCACHE_TEMPDIR="/tmp"
508 export CCACHE_COMPRESS=1
509 export CCACHE_COMPILERCHECK="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
510
511 # Remove pre-install list of installed files in case user erase some files before rebuild
512 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
513
514 # Prepare string for /etc/system-release.
515 local system_release="${NAME} ${VERSION} (${BUILD_ARCH})"
516
517 case "${GIT_BRANCH}" in
518 core*|beta?|rc?)
519 system_release="${system_release} - ${GIT_BRANCH}"
520 ;;
521 *)
522 system_release="${system_release} - core${CORE} Development Build: ${GIT_BRANCH}/${GIT_LASTCOMMIT:0:8}"
523 ;;
524 esac
525
526 # Append -dirty tag for local changes
527 if [ "$(git status -s | wc -l)" != "0" ]; then
528 system_release="${system_release}-dirty"
529 fi
530
531 # Export variable
532 SYSTEM_RELEASE="${system_release}"
533
534 # Decide on PAKFIRE_TREE
535 case "${GIT_BRANCH}" in
536 core*)
537 PAKFIRE_TREE="stable"
538 ;;
539 master)
540 PAKFIRE_TREE="testing"
541 ;;
542 *)
543 PAKFIRE_TREE="unstable"
544 ;;
545 esac
546
547 # Setup ccache cache size
548 enterchroot ccache --max-size="${CCACHE_CACHE_SIZE}" >/dev/null
549 }
550
551 enterchroot() {
552 # Install QEMU helper, if needed
553 qemu_install_helper
554
555 local PATH="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/bin"
556
557 PATH="${PATH}" chroot ${LFS} env -i \
558 HOME="/root" \
559 TERM="${TERM}" \
560 PS1="${PS1}" \
561 PATH="${PATH}" \
562 SYSTEM_RELEASE="${SYSTEM_RELEASE}" \
563 PAKFIRE_TREE="${PAKFIRE_TREE}" \
564 NAME="${NAME}" \
565 SNAME="${SNAME}" \
566 VERSION="${VERSION}" \
567 CORE="${CORE}" \
568 SLOGAN="${SLOGAN}" \
569 TOOLS_DIR="${TOOLS_DIR}" \
570 CONFIG_ROOT="${CONFIG_ROOT}" \
571 CFLAGS="${CFLAGS} ${HARDENING_CFLAGS}" \
572 CXXFLAGS="${CXXFLAGS} ${HARDENING_CFLAGS}" \
573 RUSTFLAGS="${RUSTFLAGS}" \
574 BUILDTARGET="${BUILDTARGET}" \
575 CROSSTARGET="${CROSSTARGET}" \
576 BUILD_ARCH="${BUILD_ARCH}" \
577 BUILD_PLATFORM="${BUILD_PLATFORM}" \
578 CCACHE_DIR=/usr/src/ccache \
579 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
580 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
581 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
582 GOCACHE="/usr/src/ccache/go" \
583 KVER="${KVER}" \
584 XZ_OPT="${XZ_OPT}" \
585 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
586 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
587 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
588 $(fake_environ) \
589 $(qemu_environ) \
590 "$@"
591 }
592
593 entershell() {
594 if [ ! -e $BASEDIR/build/usr/src/lfs/ ]; then
595 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/"
596 fi
597
598 echo "Entering to a shell inside LFS chroot, go out with exit"
599 local PS1="ipfire build chroot (${BUILD_ARCH}) \u:\w\$ "
600
601 if enterchroot bash -i; then
602 stdumount
603 else
604 print_status FAIL
605 exiterror "chroot error"
606 fi
607 }
608
609 lfsmakecommoncheck() {
610 # Script present?
611 if [ ! -f $BASEDIR/lfs/$1 ]; then
612 exiterror "No such file or directory: $BASEDIR/$1"
613 fi
614
615 # Print package name and version
616 print_package $@
617
618 # Check if this package is supported by our architecture.
619 # If no SUP_ARCH is found, we assume the package can be built for all.
620 if grep "^SUP_ARCH" ${BASEDIR}/lfs/${1} >/dev/null; then
621 # Check if package supports ${BUILD_ARCH} or all architectures.
622 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
623 print_runtime 0
624 print_status SKIP
625 return 1
626 fi
627 fi
628
629 # Script slipped?
630 local i
631 for i in $SKIP_PACKAGE_LIST
632 do
633 if [ "$i" == "$1" ]; then
634 print_status SKIP
635 return 1;
636 fi
637 done
638
639 echo -ne "`date -u '+%b %e %T'`: Building $* " >> $LOGFILE
640
641 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
642 MESSAGE="$1\t " download >> $LOGFILE 2>&1
643 if [ $? -ne 0 ]; then
644 exiterror "Download error in $1"
645 fi
646
647 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
648 MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
649 if [ $? -ne 0 ]; then
650 exiterror "md5sum error in $1, check file in cache or signature"
651 fi
652
653 return 0 # pass all!
654 }
655
656 lfsmake1() {
657 lfsmakecommoncheck $*
658 [ $? == 1 ] && return 0
659
660 cd $BASEDIR/lfs && env -i \
661 PATH="${TOOLS_DIR}/ccache/bin:${TOOLS_DIR}/bin:$PATH" \
662 CCACHE_DIR="${CCACHE_DIR}" \
663 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
664 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
665 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
666 CFLAGS="${CFLAGS}" \
667 CXXFLAGS="${CXXFLAGS}" \
668 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
669 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
670 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
671 make -f $* \
672 TOOLCHAIN=1 \
673 TOOLS_DIR="${TOOLS_DIR}" \
674 CROSSTARGET="${CROSSTARGET}" \
675 BUILDTARGET="${BUILDTARGET}" \
676 BUILD_ARCH="${BUILD_ARCH}" \
677 BUILD_PLATFORM="${BUILD_PLATFORM}" \
678 LFS_BASEDIR="${BASEDIR}" \
679 ROOT="${LFS}" \
680 KVER="${KVER}" \
681 install >> $LOGFILE 2>&1 &
682
683 if ! wait_until_finished $!; then
684 print_status FAIL
685 exiterror "Building $*"
686 fi
687
688 print_status DONE
689 }
690
691 lfsmake2() {
692 lfsmakecommoncheck $*
693 [ $? == 1 ] && return 0
694
695 local PS1='\u:\w$ '
696
697 enterchroot \
698 ${EXTRA_PATH}bash -x -c "cd /usr/src/lfs && \
699 make -f $* \
700 LFS_BASEDIR=/usr/src install" \
701 >> ${LOGFILE} 2>&1 &
702
703 if ! wait_until_finished $!; then
704 print_status FAIL
705 exiterror "Building $*"
706 fi
707
708 print_status DONE
709 }
710
711 ipfiredist() {
712 lfsmakecommoncheck $*
713 [ $? == 1 ] && return 0
714
715 local PS1='\u:\w$ '
716
717 enterchroot \
718 bash -x -c "cd /usr/src/lfs && make -f $* LFS_BASEDIR=/usr/src dist" \
719 >> ${LOGFILE} 2>&1 &
720
721 if ! wait_until_finished $!; then
722 print_status FAIL
723 exiterror "Packaging $*"
724 fi
725
726 print_status DONE
727 }
728
729 wait_until_finished() {
730 local pid=${1}
731
732 local start_time=$(now)
733
734 # Show progress
735 if ${INTERACTIVE}; then
736 # Wait a little just in case the process
737 # has finished very quickly.
738 sleep 0.1
739
740 local runtime
741 while kill -0 ${pid} 2>/dev/null; do
742 print_runtime $(( $(now) - ${start_time} ))
743
744 # Wait a little
745 sleep 1
746 done
747 fi
748
749 # Returns the exit code of the child process
750 wait ${pid}
751 local ret=$?
752
753 if ! ${INTERACTIVE}; then
754 print_runtime $(( $(now) - ${start_time} ))
755 fi
756
757 return ${ret}
758 }
759
760 fake_environ() {
761 [ -e "${BASEDIR}/build${TOOLS_DIR}/lib/libpakfire_preload.so" ] || return
762
763 local env="LD_PRELOAD=${TOOLS_DIR}/lib/libpakfire_preload.so"
764
765 # Fake kernel version, because some of the packages do not compile
766 # with kernel 3.0 and later.
767 env="${env} UTS_RELEASE=${KVER}-ipfire"
768
769 # Fake machine version.
770 env="${env} UTS_MACHINE=${BUILD_ARCH}"
771
772 echo "${env}"
773 }
774
775 qemu_environ() {
776 local env
777
778 # Don't add anything if qemu is not used.
779 if ! qemu_is_required; then
780 return
781 fi
782
783 # Set default qemu options
784 case "${BUILD_ARCH}" in
785 arm*)
786 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
787
788 env="${env} QEMU_CPU=${QEMU_CPU}"
789 ;;
790 esac
791
792 # Enable QEMU strace
793 #env="${env} QEMU_STRACE=1"
794
795 echo "${env}"
796 }
797
798 qemu_is_required() {
799 local build_arch="${1}"
800
801 if [ -z "${build_arch}" ]; then
802 build_arch="${BUILD_ARCH}"
803 fi
804
805 case "${HOST_ARCH},${build_arch}" in
806 x86_64,arm*|i?86,arm*|i?86,x86_64)
807 return 0
808 ;;
809 *)
810 return 1
811 ;;
812 esac
813 }
814
815 qemu_install_helper() {
816 # Do nothing, if qemu is not required
817 if ! qemu_is_required; then
818 return 0
819 fi
820
821 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
822 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable."
823 fi
824
825 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
826 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable."
827 fi
828
829
830 if [ -z "${QEMU_TARGET_HELPER}" ]; then
831 exiterror "QEMU_TARGET_HELPER not set"
832 fi
833
834 # Check if the helper is already installed.
835 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
836 return 0
837 fi
838
839 # Try to find a suitable binary that we can install
840 # to the build environment.
841 local file
842 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
843 # file must exist and be executable.
844 [ -x "${file}" ] || continue
845
846 # Must be static.
847 file_is_static "${file}" || continue
848
849 local dirname="${LFS}$(dirname "${file}")"
850 mkdir -p "${dirname}"
851
852 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
853 return 0
854 done
855
856 exiterror "Could not find a statically-linked QEMU emulator: ${QEMU_TARGET_HELPER}"
857 }
858
859 qemu_find_build_helper_name() {
860 local build_arch="${1}"
861
862 local magic
863 case "${build_arch}" in
864 arm*)
865 magic="7f454c4601010100000000000000000002002800"
866 ;;
867 x86_64)
868 magic="7f454c4602010100000000000000000002003e00"
869 ;;
870 esac
871
872 [ -z "${magic}" ] && return 1
873
874 local file
875 for file in /proc/sys/fs/binfmt_misc/*; do
876 # skip write only register entry
877 [ $(basename "${file}") = "register" ] && continue
878 # Search for the file with the correct magic value.
879 grep -qE "^magic ${magic}$" "${file}" || continue
880
881 local interpreter="$(grep "^interpreter" "${file}" | awk '{ print $2 }')"
882
883 [ -n "${interpreter}" ] || continue
884 [ "${interpreter:0:1}" = "/" ] || continue
885 [ -x "${interpreter}" ] || continue
886
887 echo "${interpreter}"
888 return 0
889 done
890
891 return 1
892 }
893
894 file_is_static() {
895 local file="${1}"
896
897 file ${file} 2>/dev/null | grep -q "statically linked"
898 }
899
900 update_language_list() {
901 local path="${1}"
902
903 local lang
904 for lang in ${path}/*.po; do
905 lang="$(basename "${lang}")"
906 echo "${lang%*.po}"
907 done | sort -u > "${path}/LINGUAS"
908 }
909
910 contributors() {
911 local commits name
912
913 git shortlog --summary --numbered | while read -r commits name; do
914 echo "${name}"
915 done | grep -vE -e "^(alpha197|morlix|root|ummeegge)$" -e "via Development$" -e "@" -e "#$"
916 }
917
918 update_contributors() {
919 echo -n "Updating list of contributors"
920
921 local contributors="$(contributors | paste -sd , - | sed -e "s/,/&\\\\n/g")"
922
923 # Edit contributors into credits.cgi
924 local tmp="$(mktemp)"
925
926 awk "/<!-- CONTRIBUTORS -->/{ p=1; print; printf \"${contributors}\n\"}/<!-- END -->/{ p=0 } !p" \
927 < "${BASEDIR}/html/cgi-bin/credits.cgi" > "${tmp}"
928
929 # Copy back modified content
930 cat "${tmp}" > "${BASEDIR}/html/cgi-bin/credits.cgi"
931 unlink "${tmp}"
932
933 print_status DONE
934 return 0
935 }
936
937 # Default settings
938 CCACHE_CACHE_SIZE="4G"
939 ENABLE_RAMDISK="auto"
940
941 # Load configuration file
942 if [ -f .config ]; then
943 . .config
944 fi
945
946 # TARGET_ARCH is BUILD_ARCH now
947 if [ -n "${TARGET_ARCH}" ]; then
948 BUILD_ARCH="${TARGET_ARCH}"
949 unset TARGET_ARCH
950 fi
951
952 # Get some information about the host system
953 SYSTEM_PROCESSORS="$(system_processors)"
954 SYSTEM_MEMORY="$(system_memory)"
955
956 if [ -n "${BUILD_ARCH}" ]; then
957 configure_build "${BUILD_ARCH}"
958 else
959 configure_build "default"
960 fi
961
962 # Automatically enable/disable ramdisk usage
963 if [ "${ENABLE_RAMDISK}" = "auto" ]; then
964 # Enable only when the host system has 4GB of RAM or more
965 if [ ${SYSTEM_MEMORY} -ge 3900 ]; then
966 ENABLE_RAMDISK="on"
967 fi
968 fi
969
970 buildtoolchain() {
971 local error=false
972 case "${BUILD_ARCH}:${HOST_ARCH}" in
973 # x86_64
974 x86_64:x86_64)
975 # This is working.
976 ;;
977
978 # x86
979 i586:i586|i586:i686|i586:x86_64)
980 # These are working.
981 ;;
982 i586:*)
983 error=true
984 ;;
985
986 # ARM
987 arvm7hl:armv7hl|armv7hl:armv7l)
988 # These are working.
989 ;;
990
991 armv5tel:armv5tel|armv5tel:armv5tejl|armv5tel:armv6l|armv5tel:armv7l|armv5tel:aarch64)
992 # These are working.
993 ;;
994 armv5tel:*)
995 error=true
996 ;;
997 esac
998
999 ${error} && \
1000 exiterror "Cannot build ${BUILD_ARCH} toolchain on $(uname -m). Please use the download if any."
1001
1002 local gcc=$(type -p gcc)
1003 if [ -z "${gcc}" ]; then
1004 exiterror "Could not find GCC. You will need a working build enviroment in order to build the toolchain."
1005 fi
1006
1007 # Check ${TOOLS_DIR} symlink
1008 if [ -h "${TOOLS_DIR}" ]; then
1009 rm -f "${TOOLS_DIR}"
1010 fi
1011
1012 if [ ! -e "${TOOLS_DIR}" ]; then
1013 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
1014 fi
1015
1016 if [ ! -h "${TOOLS_DIR}" ]; then
1017 exiterror "Could not create ${TOOLS_DIR} symbolic link"
1018 fi
1019
1020 LOGFILE="$BASEDIR/log/_build.toolchain.log"
1021 export LOGFILE
1022
1023 lfsmake1 stage1
1024 lfsmake1 ccache PASS=1
1025 lfsmake1 binutils PASS=1
1026 lfsmake1 gcc PASS=1
1027 lfsmake1 linux KCFG="-headers"
1028 lfsmake1 glibc
1029 lfsmake1 gcc PASS=L
1030 lfsmake1 binutils PASS=2
1031 lfsmake1 gcc PASS=2
1032 lfsmake1 zlib
1033 lfsmake1 ccache PASS=2
1034 lfsmake1 tcl
1035 lfsmake1 expect
1036 lfsmake1 dejagnu
1037 lfsmake1 pkg-config
1038 lfsmake1 ncurses
1039 lfsmake1 bash
1040 lfsmake1 bzip2
1041 lfsmake1 automake
1042 lfsmake1 coreutils
1043 lfsmake1 diffutils
1044 lfsmake1 findutils
1045 lfsmake1 gawk
1046 lfsmake1 gettext
1047 lfsmake1 grep
1048 lfsmake1 gzip
1049 lfsmake1 m4
1050 lfsmake1 make
1051 lfsmake1 patch
1052 lfsmake1 perl
1053 lfsmake1 python3
1054 lfsmake1 sed
1055 lfsmake1 tar
1056 lfsmake1 texinfo
1057 lfsmake1 xz
1058 lfsmake1 bison
1059 lfsmake1 flex
1060 lfsmake1 fake-environ
1061 lfsmake1 strip
1062 lfsmake1 cleanup-toolchain
1063 }
1064
1065 buildbase() {
1066 LOGFILE="$BASEDIR/log/_build.base.log"
1067 export LOGFILE
1068 lfsmake2 stage2
1069 lfsmake2 linux KCFG="-headers"
1070 lfsmake2 man-pages
1071 lfsmake2 glibc
1072 lfsmake2 tzdata
1073 lfsmake2 cleanup-toolchain
1074 lfsmake2 zlib
1075 lfsmake2 binutils
1076 lfsmake2 gmp
1077 lfsmake2 gmp-compat
1078 lfsmake2 mpfr
1079 lfsmake2 libmpc
1080 lfsmake2 file
1081 lfsmake2 gcc
1082 lfsmake2 sed
1083 lfsmake2 autoconf
1084 lfsmake2 automake
1085 lfsmake2 berkeley
1086 lfsmake2 coreutils
1087 lfsmake2 iana-etc
1088 lfsmake2 m4
1089 lfsmake2 bison
1090 lfsmake2 ncurses
1091 lfsmake2 procps
1092 lfsmake2 libtool
1093 lfsmake2 perl
1094 lfsmake2 readline
1095 lfsmake2 readline-compat
1096 lfsmake2 bzip2
1097 lfsmake2 xz
1098 lfsmake2 pcre
1099 lfsmake2 pcre-compat
1100 lfsmake2 bash
1101 lfsmake2 diffutils
1102 lfsmake2 e2fsprogs
1103 lfsmake2 ed
1104 lfsmake2 findutils
1105 lfsmake2 flex
1106 lfsmake2 gawk
1107 lfsmake2 gettext
1108 lfsmake2 grep
1109 lfsmake2 groff
1110 lfsmake2 gperf
1111 lfsmake2 gzip
1112 lfsmake2 hostname
1113 lfsmake2 iproute2
1114 lfsmake2 jwhois
1115 lfsmake2 kbd
1116 lfsmake2 less
1117 lfsmake2 pkg-config
1118 lfsmake2 make
1119 lfsmake2 man
1120 lfsmake2 net-tools
1121 lfsmake2 patch
1122 lfsmake2 psmisc
1123 lfsmake2 shadow
1124 lfsmake2 sysklogd
1125 lfsmake2 sysvinit
1126 lfsmake2 tar
1127 lfsmake2 texinfo
1128 lfsmake2 util-linux
1129 lfsmake2 vim
1130 }
1131
1132 buildipfire() {
1133 LOGFILE="$BASEDIR/log/_build.ipfire.log"
1134 export LOGFILE
1135 lfsmake2 configroot
1136 lfsmake2 initscripts
1137 lfsmake2 backup
1138 lfsmake2 openssl
1139 [ "${BUILD_ARCH}" = "i586" ] && lfsmake2 openssl KCFG='-sse2'
1140 lfsmake2 kmod
1141 lfsmake2 udev
1142 lfsmake2 popt
1143 lfsmake2 libedit
1144 lfsmake2 libusb
1145 lfsmake2 libusb-compat
1146 lfsmake2 libpcap
1147 lfsmake2 ppp
1148 lfsmake2 pptp
1149 lfsmake2 unzip
1150 lfsmake2 which
1151 lfsmake2 linux-firmware
1152 lfsmake2 dvb-firmwares
1153 lfsmake2 xr819-firmware
1154 lfsmake2 zd1211-firmware
1155 lfsmake2 rpi-firmware
1156 lfsmake2 intel-microcode
1157 lfsmake2 pcengines-apu-firmware
1158 lfsmake2 bc
1159 lfsmake2 u-boot MKIMAGE=1
1160 lfsmake2 cpio
1161 lfsmake2 mdadm
1162 lfsmake2 dracut
1163 lfsmake2 libaio
1164 lfsmake2 lvm2
1165 lfsmake2 multipath-tools
1166 lfsmake2 freetype
1167 lfsmake2 libmnl
1168 lfsmake2 libnfnetlink
1169 lfsmake2 libnetfilter_queue
1170 lfsmake2 libnetfilter_conntrack
1171 lfsmake2 libnetfilter_cthelper
1172 lfsmake2 libnetfilter_cttimeout
1173 lfsmake2 iptables
1174 lfsmake2 screen
1175 lfsmake2 elfutils
1176
1177 case "${BUILD_ARCH}" in
1178 x86_64|aarch64)
1179 lfsmake2 linux KCFG=""
1180 # lfsmake2 backports KCFG=""
1181 # lfsmake2 e1000e KCFG=""
1182 # lfsmake2 igb KCFG=""
1183 # lfsmake2 ixgbe KCFG=""
1184 lfsmake2 xtables-addons KCFG=""
1185 lfsmake2 linux-initrd KCFG=""
1186 ;;
1187 i586)
1188 # x86-pae (Native and new XEN) kernel build
1189 lfsmake2 linux KCFG="-pae"
1190 # lfsmake2 backports KCFG="-pae"
1191 # lfsmake2 e1000e KCFG="-pae"
1192 # lfsmake2 igb KCFG="-pae"
1193 # lfsmake2 ixgbe KCFG="-pae"
1194 lfsmake2 xtables-addons KCFG="-pae"
1195 lfsmake2 linux-initrd KCFG="-pae"
1196
1197 # x86 kernel build
1198 lfsmake2 linux KCFG=""
1199 # lfsmake2 backports KCFG=""
1200 # lfsmake2 e1000e KCFG=""
1201 # lfsmake2 igb KCFG=""
1202 # lfsmake2 ixgbe KCFG=""
1203 lfsmake2 xtables-addons KCFG=""
1204 lfsmake2 linux-initrd KCFG=""
1205 ;;
1206
1207 armv5tel)
1208 # arm multi platform (Panda, Wandboard ...) kernel build
1209 lfsmake2 linux KCFG="-multi"
1210 # lfsmake2 backports KCFG="-multi"
1211 # lfsmake2 e1000e KCFG="-multi"
1212 # lfsmake2 igb KCFG="-multi"
1213 # lfsmake2 ixgbe KCFG="-multi"
1214 lfsmake2 xtables-addons KCFG="-multi"
1215 lfsmake2 linux-initrd KCFG="-multi"
1216 ;;
1217 esac
1218 lfsmake2 xtables-addons USPACE="1"
1219 lfsmake2 libgpg-error
1220 lfsmake2 libgcrypt
1221 lfsmake2 libassuan
1222 lfsmake2 nettle
1223 lfsmake2 json-c
1224 lfsmake2 libconfig
1225 lfsmake2 libevent
1226 lfsmake2 libevent2
1227 lfsmake2 expat
1228 lfsmake2 apr
1229 lfsmake2 aprutil
1230 lfsmake2 unbound
1231 lfsmake2 gnutls
1232 lfsmake2 bind
1233 lfsmake2 dhcp
1234 lfsmake2 dhcpcd
1235 lfsmake2 boost
1236 lfsmake2 linux-atm
1237 lfsmake2 gdbm
1238 lfsmake2 pam
1239 lfsmake2 curl
1240 lfsmake2 tcl
1241 lfsmake2 sqlite
1242 lfsmake2 libffi
1243 lfsmake2 python
1244 lfsmake2 python3
1245 lfsmake2 grub
1246 lfsmake2 efivar
1247 lfsmake2 efibootmgr
1248 lfsmake2 ca-certificates
1249 lfsmake2 fireinfo
1250 lfsmake2 libnet
1251 lfsmake2 libnl
1252 lfsmake2 libnl-3
1253 lfsmake2 libidn
1254 lfsmake2 nasm
1255 lfsmake2 libjpeg
1256 lfsmake2 libjpeg-compat
1257 lfsmake2 libexif
1258 lfsmake2 libpng
1259 lfsmake2 libtiff
1260 lfsmake2 libart
1261 lfsmake2 gd
1262 lfsmake2 slang
1263 lfsmake2 newt
1264 lfsmake2 libsmooth
1265 lfsmake2 attr
1266 lfsmake2 acl
1267 lfsmake2 libcap
1268 lfsmake2 libcap-ng
1269 lfsmake2 pciutils
1270 lfsmake2 usbutils
1271 lfsmake2 libxml2
1272 lfsmake2 libxslt
1273 lfsmake2 BerkeleyDB
1274 lfsmake2 cyrus-sasl
1275 lfsmake2 openldap
1276 lfsmake2 apache2
1277 lfsmake2 web-user-interface
1278 lfsmake2 flag-icons
1279 lfsmake2 jquery
1280 lfsmake2 bootstrap
1281 lfsmake2 arping
1282 lfsmake2 beep
1283 lfsmake2 libarchive
1284 lfsmake2 cmake
1285 lfsmake2 libssh
1286 lfsmake2 cdrkit
1287 lfsmake2 dosfstools
1288 lfsmake2 reiserfsprogs
1289 lfsmake2 xfsprogs
1290 lfsmake2 sysfsutils
1291 lfsmake2 fuse
1292 lfsmake2 ntfs-3g
1293 lfsmake2 ethtool
1294 lfsmake2 fcron
1295 lfsmake2 perl-GD
1296 lfsmake2 GD-Graph
1297 lfsmake2 GD-TextUtil
1298 lfsmake2 perl-Device-SerialPort
1299 lfsmake2 perl-Device-Modem
1300 lfsmake2 perl-Apache-Htpasswd
1301 lfsmake2 gnupg
1302 lfsmake2 hdparm
1303 lfsmake2 sdparm
1304 lfsmake2 mtools
1305 lfsmake2 whatmask
1306 lfsmake2 conntrack-tools
1307 lfsmake2 libupnp
1308 lfsmake2 ipaddr
1309 lfsmake2 iputils
1310 lfsmake2 l7-protocols
1311 lfsmake2 hwdata
1312 lfsmake2 logrotate
1313 lfsmake2 logwatch
1314 lfsmake2 misc-progs
1315 lfsmake2 nano
1316 lfsmake2 URI
1317 lfsmake2 perl-CGI
1318 lfsmake2 perl-Switch
1319 lfsmake2 HTML-Tagset
1320 lfsmake2 HTML-Parser
1321 lfsmake2 HTML-Template
1322 lfsmake2 Compress-Zlib
1323 lfsmake2 Digest
1324 lfsmake2 Digest-SHA1
1325 lfsmake2 Digest-HMAC
1326 lfsmake2 libwww-perl
1327 lfsmake2 Net-DNS
1328 lfsmake2 Net-IPv4Addr
1329 lfsmake2 Net_SSLeay
1330 lfsmake2 IO-Stringy
1331 lfsmake2 IO-Socket-SSL
1332 lfsmake2 Unix-Syslog
1333 lfsmake2 Mail-Tools
1334 lfsmake2 MIME-Tools
1335 lfsmake2 Net-Server
1336 lfsmake2 Convert-TNEF
1337 lfsmake2 Convert-UUlib
1338 lfsmake2 Archive-Tar
1339 lfsmake2 Archive-Zip
1340 lfsmake2 Text-Tabs+Wrap
1341 lfsmake2 Locale-Country
1342 lfsmake2 XML-Parser
1343 lfsmake2 Crypt-PasswdMD5
1344 lfsmake2 Net-Telnet
1345 lfsmake2 python-setuptools
1346 lfsmake2 python-clientform
1347 lfsmake2 python-mechanize
1348 lfsmake2 python-feedparser
1349 lfsmake2 python-rssdler
1350 lfsmake2 python-inotify
1351 lfsmake2 python-docutils
1352 lfsmake2 python-daemon
1353 lfsmake2 python-ipaddress
1354 lfsmake2 glib
1355 lfsmake2 GeoIP
1356 lfsmake2 geoip-database
1357 lfsmake2 ntp
1358 lfsmake2 openssh
1359 lfsmake2 fontconfig
1360 lfsmake2 dejavu-fonts-ttf
1361 lfsmake2 ubuntu-font-family
1362 lfsmake2 freefont
1363 lfsmake2 pixman
1364 lfsmake2 cairo
1365 lfsmake2 pango
1366 lfsmake2 rrdtool
1367 lfsmake2 setup
1368 lfsmake2 libdnet
1369 lfsmake2 rust
1370 lfsmake2 jansson
1371 lfsmake2 yaml
1372 lfsmake2 libhtp
1373 lfsmake2 colm
1374 lfsmake2 ragel
1375 lfsmake2 hyperscan
1376 lfsmake2 suricata
1377 lfsmake2 oinkmaster
1378 lfsmake2 ids-ruleset-sources
1379 lfsmake2 squid
1380 lfsmake2 squidguard
1381 lfsmake2 calamaris
1382 lfsmake2 tcpdump
1383 lfsmake2 traceroute
1384 lfsmake2 vlan
1385 lfsmake2 wireless
1386 lfsmake2 pakfire
1387 lfsmake2 spandsp
1388 lfsmake2 lz4
1389 lfsmake2 lzo
1390 lfsmake2 openvpn
1391 lfsmake2 mpage
1392 lfsmake2 dbus
1393 lfsmake2 intltool
1394 lfsmake2 libdaemon
1395 lfsmake2 avahi
1396 lfsmake2 cups
1397 lfsmake2 lcms2
1398 lfsmake2 ghostscript
1399 lfsmake2 qpdf
1400 lfsmake2 poppler
1401 lfsmake2 cups-filters
1402 lfsmake2 epson-inkjet-printer-escpr
1403 lfsmake2 foomatic
1404 lfsmake2 hplip
1405 lfsmake2 cifs-utils
1406 lfsmake2 krb5
1407 lfsmake2 samba
1408 lfsmake2 sudo
1409 lfsmake2 mc
1410 lfsmake2 wget
1411 lfsmake2 bridge-utils
1412 lfsmake2 smartmontools
1413 lfsmake2 htop
1414 lfsmake2 chkconfig
1415 lfsmake2 postfix
1416 lfsmake2 fetchmail
1417 lfsmake2 clamav
1418 lfsmake2 perl-NetAddr-IP
1419 lfsmake2 spamassassin
1420 lfsmake2 perl-Net-LibIDN
1421 lfsmake2 amavisd
1422 lfsmake2 dma
1423 lfsmake2 alsa
1424 lfsmake2 mpfire
1425 lfsmake2 guardian
1426 lfsmake2 libid3tag
1427 lfsmake2 libmad
1428 lfsmake2 libogg
1429 lfsmake2 libvorbis
1430 lfsmake2 libdvbpsi
1431 lfsmake2 flac
1432 lfsmake2 lame
1433 lfsmake2 sox
1434 lfsmake2 soxr
1435 lfsmake2 libshout
1436 lfsmake2 xvid
1437 lfsmake2 libmpeg2
1438 lfsmake2 gnump3d
1439 lfsmake2 rsync
1440 lfsmake2 libtirpc
1441 lfsmake2 rpcbind
1442 lfsmake2 keyutils
1443 lfsmake2 nfs
1444 lfsmake2 gnu-netcat
1445 lfsmake2 ncat
1446 lfsmake2 nmap
1447 lfsmake2 etherwake
1448 lfsmake2 bwm-ng
1449 lfsmake2 sysstat
1450 lfsmake2 strongswan
1451 lfsmake2 rng-tools
1452 lfsmake2 lsof
1453 lfsmake2 br2684ctl
1454 lfsmake2 pcmciautils
1455 lfsmake2 lm_sensors
1456 lfsmake2 liboping
1457 lfsmake2 collectd
1458 lfsmake2 elinks
1459 lfsmake2 igmpproxy
1460 lfsmake2 fbset
1461 lfsmake2 opus
1462 lfsmake2 python-six
1463 lfsmake2 python-pyparsing
1464 lfsmake2 spice-protocol
1465 lfsmake2 spice
1466 lfsmake2 sdl
1467 lfsmake2 libusbredir
1468 lfsmake2 libseccomp
1469 lfsmake2 qemu
1470 lfsmake2 sane
1471 lfsmake2 netpbm
1472 lfsmake2 netsnmpd
1473 lfsmake2 nagios_nrpe
1474 lfsmake2 nagios-plugins
1475 lfsmake2 icinga
1476 lfsmake2 observium-agent
1477 lfsmake2 ebtables
1478 lfsmake2 faad2
1479 lfsmake2 alac
1480 lfsmake2 ffmpeg
1481 lfsmake2 vdr
1482 lfsmake2 vdr_streamdev
1483 lfsmake2 vdr_epgsearch
1484 lfsmake2 vdr_dvbapi
1485 lfsmake2 vdr_eepg
1486 lfsmake2 w_scan
1487 lfsmake2 mpd
1488 lfsmake2 libmpdclient
1489 lfsmake2 mpc
1490 lfsmake2 perl-Net-CIDR-Lite
1491 lfsmake2 perl-Net-SMTP-SSL
1492 lfsmake2 perl-MIME-Base64
1493 lfsmake2 perl-Authen-SASL
1494 lfsmake2 perl-MIME-Lite
1495 lfsmake2 perl-Email-Date-Format
1496 lfsmake2 git
1497 lfsmake2 squidclamav
1498 lfsmake2 vnstat
1499 lfsmake2 iw
1500 lfsmake2 wpa_supplicant
1501 lfsmake2 hostapd
1502 lfsmake2 pycurl
1503 lfsmake2 urlgrabber
1504 lfsmake2 syslinux
1505 lfsmake2 tftpd
1506 lfsmake2 cpufrequtils
1507 lfsmake2 gutenprint
1508 lfsmake2 apcupsd
1509 lfsmake2 iperf
1510 lfsmake2 iperf3
1511 lfsmake2 7zip
1512 lfsmake2 lynis
1513 lfsmake2 sshfs
1514 lfsmake2 taglib
1515 lfsmake2 sslh
1516 lfsmake2 perl-gettext
1517 lfsmake2 perl-Sort-Naturally
1518 lfsmake2 vdradmin
1519 lfsmake2 perl-DBI
1520 lfsmake2 perl-DBD-SQLite
1521 lfsmake2 perl-File-ReadBackwards
1522 lfsmake2 openvmtools
1523 lfsmake2 motion
1524 lfsmake2 joe
1525 lfsmake2 monit
1526 lfsmake2 nut
1527 lfsmake2 watchdog
1528 lfsmake2 libpri
1529 lfsmake2 libsrtp
1530 lfsmake2 asterisk
1531 lfsmake2 usb_modeswitch
1532 lfsmake2 usb_modeswitch_data
1533 lfsmake2 zerofree
1534 lfsmake2 minicom
1535 lfsmake2 ddrescue
1536 lfsmake2 miniupnpd
1537 lfsmake2 client175
1538 lfsmake2 powertop
1539 lfsmake2 parted
1540 lfsmake2 swig
1541 lfsmake2 u-boot
1542 lfsmake2 u-boot-friendlyarm
1543 lfsmake2 python-typing
1544 lfsmake2 python-m2crypto
1545 lfsmake2 wireless-regdb
1546 lfsmake2 crda
1547 lfsmake2 libsolv
1548 lfsmake2 python-distutils-extra
1549 lfsmake2 python-lzma
1550 lfsmake2 python-progressbar
1551 lfsmake2 python-xattr
1552 lfsmake2 ddns
1553 lfsmake2 python3-setuptools
1554 lfsmake2 python3-setuptools-scm
1555 lfsmake2 python3-six
1556 lfsmake2 python3-dateutil
1557 lfsmake2 python3-jmespath
1558 lfsmake2 python3-colorama
1559 lfsmake2 python3-docutils
1560 lfsmake2 python3-yaml
1561 lfsmake2 python3-s3transfer
1562 lfsmake2 python3-rsa
1563 lfsmake2 python3-pyasn1
1564 lfsmake2 python3-botocore
1565 lfsmake2 python3-llfuse
1566 lfsmake2 python3-msgpack
1567 lfsmake2 aws-cli
1568 lfsmake2 transmission
1569 lfsmake2 dpfhack
1570 lfsmake2 lcd4linux
1571 lfsmake2 mtr
1572 lfsmake2 minidlna
1573 lfsmake2 acpid
1574 lfsmake2 fping
1575 lfsmake2 telnet
1576 lfsmake2 xinetd
1577 lfsmake2 gpgme
1578 lfsmake2 pygpgme
1579 lfsmake2 pakfire3
1580 lfsmake2 stress
1581 lfsmake2 libstatgrab
1582 lfsmake2 sarg
1583 lfsmake2 nginx
1584 lfsmake2 sendEmail
1585 lfsmake2 sysbench
1586 lfsmake2 strace
1587 lfsmake2 ltrace
1588 lfsmake2 ipfire-netboot
1589 lfsmake2 lcdproc
1590 lfsmake2 keepalived
1591 lfsmake2 ipvsadm
1592 lfsmake2 perl-Carp-Clan
1593 lfsmake2 perl-Date-Calc
1594 lfsmake2 perl-Date-Manip
1595 lfsmake2 perl-File-Tail
1596 lfsmake2 perl-TimeDate
1597 lfsmake2 swatch
1598 lfsmake2 tor
1599 lfsmake2 wavemon
1600 lfsmake2 iptraf-ng
1601 lfsmake2 iotop
1602 lfsmake2 stunnel
1603 lfsmake2 bacula
1604 lfsmake2 perl-Font-TTF
1605 lfsmake2 perl-IO-String
1606 lfsmake2 perl-PDF-API2
1607 lfsmake2 squid-accounting
1608 lfsmake2 pigz
1609 lfsmake2 tmux
1610 lfsmake2 perl-Text-CSV_XS
1611 lfsmake2 lua
1612 lfsmake2 haproxy
1613 lfsmake2 ipset
1614 lfsmake2 dnsdist
1615 lfsmake2 bird
1616 lfsmake2 frr
1617 lfsmake2 dmidecode
1618 lfsmake2 mcelog
1619 lfsmake2 util-macros
1620 lfsmake2 libpciaccess
1621 lfsmake2 libyajl
1622 lfsmake2 libvirt
1623 lfsmake2 freeradius
1624 lfsmake2 perl-common-sense
1625 lfsmake2 perl-inotify2
1626 lfsmake2 perl-Net-IP
1627 lfsmake2 wio
1628 lfsmake2 iftop
1629 lfsmake2 mdns-repeater
1630 lfsmake2 i2c-tools
1631 lfsmake2 nss-myhostname
1632 lfsmake2 dehydrated
1633 lfsmake2 shairport-sync
1634 lfsmake2 borgbackup
1635 lfsmake2 knot
1636 lfsmake2 spectre-meltdown-checker
1637 lfsmake2 zabbix_agentd
1638 lfsmake2 flashrom
1639 lfsmake2 firmware-update
1640 lfsmake2 tshark
1641 lfsmake2 geoip-generator
1642 lfsmake2 speedtest-cli
1643 lfsmake2 rfkill
1644 lfsmake2 amazon-ssm-agent
1645 }
1646
1647 buildinstaller() {
1648 # Run installer scripts one by one
1649 LOGFILE="$BASEDIR/log/_build.installer.log"
1650 export LOGFILE
1651 lfsmake2 memtest
1652 lfsmake2 installer
1653 # use toolchain bash for chroot to strip
1654 EXTRA_PATH=${TOOLS_DIR}/bin/ lfsmake2 strip
1655 }
1656
1657 buildpackages() {
1658 LOGFILE="$BASEDIR/log/_build.packages.log"
1659 export LOGFILE
1660 echo "... see detailed log in _build.*.log files" >> $LOGFILE
1661
1662
1663 # Generating list of packages used
1664 print_line "Generating packages list from logs"
1665 rm -f $BASEDIR/doc/packages-list
1666 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
1667 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
1668 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
1669 fi
1670 done
1671 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
1672 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
1673 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
1674 rm -f $BASEDIR/doc/packages-list
1675 # packages-list.txt is ready to be displayed for wiki page
1676 print_status DONE
1677
1678 # Update changelog
1679 cd $BASEDIR
1680 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
1681 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
1682 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
1683
1684 # Create images for install
1685 lfsmake2 cdrom
1686
1687 # Check if there is a loop device for building in virtual environments
1688 modprobe loop 2>/dev/null
1689 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev/loop/0 ] || [ -e /dev/loop0 ] || [ -e "/dev/loop-control" ]); then
1690 lfsmake2 flash-images
1691 fi
1692
1693 mv $LFS/install/images/{*.iso,*.img.xz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
1694
1695 ipfirepackages
1696
1697 lfsmake2 xen-image
1698 mv $LFS/install/images/*.bz2 $BASEDIR >> $LOGFILE 2>&1
1699
1700 cd $BASEDIR
1701
1702 # remove not useable iso on armv5tel (needed to build flash images)
1703 [ "${BUILD_ARCH}" = "armv5tel" ] && rm -rf *.iso
1704
1705 for i in `ls *.bz2 *.img.xz *.iso`; do
1706 md5sum $i > $i.md5
1707 done
1708 cd $PWD
1709
1710 # Cleanup
1711 stdumount
1712 rm -rf $BASEDIR/build/tmp/*
1713
1714 cd $PWD
1715 }
1716
1717 ipfirepackages() {
1718 lfsmake2 core-updates
1719
1720 local i
1721 for i in $(find $BASEDIR/config/rootfiles/packages{/${BUILD_ARCH},} -maxdepth 1 -type f); do
1722 i=$(basename ${i})
1723 if [ -e $BASEDIR/lfs/$i ]; then
1724 ipfiredist $i
1725 else
1726 echo -n $i
1727 print_status SKIP
1728 fi
1729 done
1730 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
1731 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
1732 rm -rf $BASEDIR/build/install/packages/*
1733 }
1734
1735 while [ $# -gt 0 ]; do
1736 case "${1}" in
1737 --target=*)
1738 configure_build "${1#--target=}"
1739 ;;
1740 -*)
1741 exiterror "Unknown configuration option: ${1}"
1742 ;;
1743 *)
1744 # Found a command, so exit options parsing.
1745 break
1746 ;;
1747 esac
1748 shift
1749 done
1750
1751 # See what we're supposed to do
1752 case "$1" in
1753 build)
1754 START_TIME=$(now)
1755
1756 # Clear screen
1757 ${INTERACTIVE} && clear
1758
1759 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz 2> /dev/null | head -n 1`
1760 #only restore on a clean disk
1761 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
1762 if [ ! -n "$PACKAGE" ]; then
1763 print_build_stage "Full toolchain compilation"
1764 prepareenv
1765 buildtoolchain
1766 else
1767 PACKAGENAME=${PACKAGE%.tar.xz}
1768 print_build_stage "Packaged toolchain compilation"
1769 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
1770 tar axf $PACKAGE
1771 prepareenv
1772 else
1773 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
1774 fi
1775 fi
1776 else
1777 prepareenv
1778 fi
1779
1780 print_build_stage "Building LFS"
1781 buildbase
1782
1783 print_build_stage "Building IPFire"
1784 buildipfire
1785
1786 print_build_stage "Building installer"
1787 buildinstaller
1788
1789 print_build_stage "Building packages"
1790 buildpackages
1791
1792 print_build_stage "Checking Logfiles for new Files"
1793
1794 cd $BASEDIR
1795 tools/checknewlog.pl
1796 tools/checkrootfiles
1797 cd $PWD
1798
1799 print_build_summary $(( $(now) - ${START_TIME} ))
1800 ;;
1801 shell)
1802 # enter a shell inside LFS chroot
1803 # may be used to changed kernel settings
1804 prepareenv
1805 entershell
1806 ;;
1807 clean)
1808 print_line "Cleaning build directory..."
1809
1810 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1811 $LOSETUP -d $i 2>/dev/null
1812 done
1813 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1814 umount $i
1815 done
1816 stdumount
1817 for i in `seq 0 7`; do
1818 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
1819 umount /dev/loop${i} 2>/dev/null;
1820 losetup -d /dev/loop${i} 2>/dev/null;
1821 fi;
1822 done
1823 rm -rf $BASEDIR/build
1824 rm -rf $BASEDIR/cdrom
1825 rm -rf $BASEDIR/packages
1826 rm -rf $BASEDIR/log
1827 if [ -h "${TOOLS_DIR}" ]; then
1828 rm -f "${TOOLS_DIR}"
1829 fi
1830 rm -f $BASEDIR/ipfire-*
1831 print_status DONE
1832 ;;
1833 docker)
1834 # Build the docker image if it does not exist, yet
1835 if ! docker images -a | grep -q ^ipfire-builder; then
1836 if docker build -t ipfire-builder ${BASEDIR}/tools/docker; then
1837 print_status DONE
1838 else
1839 print_status FAIL
1840 exit 1
1841 fi
1842 fi
1843
1844 # Run the container and enter a shell
1845 docker run -it --privileged -v "${BASEDIR}:/build" -w "/build" ipfire-builder bash -l
1846 ;;
1847 downloadsrc)
1848 if [ ! -d $BASEDIR/cache ]; then
1849 mkdir $BASEDIR/cache
1850 fi
1851 mkdir -p $BASEDIR/log
1852 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
1853 FINISHED=0
1854 cd $BASEDIR/lfs
1855 for c in `seq $MAX_RETRIES`; do
1856 if (( FINISHED==1 )); then
1857 break
1858 fi
1859 FINISHED=1
1860 cd $BASEDIR/lfs
1861 for i in *; do
1862 if [ -f "$i" -a "$i" != "Config" ]; then
1863 lfsmakecommoncheck ${i} || continue
1864
1865 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
1866 MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
1867 if [ $? -ne 0 ]; then
1868 print_status FAIL
1869 FINISHED=0
1870 else
1871 if [ $c -eq 1 ]; then
1872 print_status DONE
1873 fi
1874 fi
1875 fi
1876 done
1877 done
1878 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
1879 ERROR=0
1880 for i in *; do
1881 if [ -f "$i" -a "$i" != "Config" ]; then
1882 lfsmakecommoncheck ${i} > /dev/null || continue
1883 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
1884 MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
1885 if [ $? -ne 0 ]; then
1886 echo -ne "MD5 difference in lfs/$i"
1887 print_status FAIL
1888 ERROR=1
1889 fi
1890 fi
1891 done
1892 if [ $ERROR -eq 0 ]; then
1893 echo -ne "${BOLD}all files md5sum match${NORMAL}"
1894 print_status DONE
1895 else
1896 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
1897 print_status FAIL
1898 fi
1899 cd - >/dev/null 2>&1
1900 ;;
1901 toolchain)
1902 # Clear screen
1903 ${INTERACTIVE} && clear
1904
1905 prepareenv
1906 print_build_stage "Toolchain compilation (${BUILD_ARCH})"
1907 buildtoolchain
1908 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
1909 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
1910 cd $BASEDIR && tar -cf- --exclude='log/_build.*.log' build/${TOOLS_DIR} build/bin/sh log | xz ${XZ_OPT} \
1911 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz
1912 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz \
1913 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.md5
1914 stdumount
1915 ;;
1916 gettoolchain)
1917 # arbitrary name to be updated in case of new toolchain package upload
1918 PACKAGE=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
1919 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.xz ]; then
1920 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
1921 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
1922 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
1923 cd $BASEDIR/cache/toolchains
1924 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.xz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
1925 if [ $? -ne 0 ]; then
1926 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" | tee -a $LOGFILE
1927 else
1928 if [ "`md5sum $PACKAGE.tar.xz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
1929 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
1930 else
1931 exiterror "$PACKAGE.md5 did not match, check downloaded package"
1932 fi
1933 fi
1934 else
1935 echo "Toolchain is already downloaded. Exiting..."
1936 fi
1937 ;;
1938 uploadsrc)
1939 PWD=`pwd`
1940 if [ -z $IPFIRE_USER ]; then
1941 echo -n "You have to setup IPFIRE_USER first. See .config for details."
1942 print_status FAIL
1943 exit 1
1944 fi
1945
1946 URL_SOURCE=$(grep URL_SOURCE lfs/Config | awk '{ print $3 }')
1947 REMOTE_FILES=$(echo "ls -1" | sftp -C ${IPFIRE_USER}@${URL_SOURCE})
1948
1949 for file in ${BASEDIR}/cache/*; do
1950 [ -d "${file}" ] && continue
1951 grep -q "$(basename ${file})" <<<$REMOTE_FILES && continue
1952 NEW_FILES="$NEW_FILES $file"
1953 done
1954 [ -n "$NEW_FILES" ] && scp -2 $NEW_FILES ${IPFIRE_USER}@${URL_SOURCE}
1955 cd $BASEDIR
1956 cd $PWD
1957 exit 0
1958 ;;
1959 lang)
1960 echo -ne "Checking the translations for missing or obsolete strings..."
1961 chmod 755 $BASEDIR/tools/{check_strings.pl,sort_strings.pl,check_langs.sh}
1962 $BASEDIR/tools/sort_strings.pl en
1963 $BASEDIR/tools/sort_strings.pl de
1964 $BASEDIR/tools/sort_strings.pl fr
1965 $BASEDIR/tools/sort_strings.pl es
1966 $BASEDIR/tools/sort_strings.pl pl
1967 $BASEDIR/tools/sort_strings.pl ru
1968 $BASEDIR/tools/sort_strings.pl nl
1969 $BASEDIR/tools/sort_strings.pl tr
1970 $BASEDIR/tools/sort_strings.pl it
1971 $BASEDIR/tools/check_strings.pl en > $BASEDIR/doc/language_issues.en
1972 $BASEDIR/tools/check_strings.pl de > $BASEDIR/doc/language_issues.de
1973 $BASEDIR/tools/check_strings.pl fr > $BASEDIR/doc/language_issues.fr
1974 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.es
1975 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.pl
1976 $BASEDIR/tools/check_strings.pl ru > $BASEDIR/doc/language_issues.ru
1977 $BASEDIR/tools/check_strings.pl nl > $BASEDIR/doc/language_issues.nl
1978 $BASEDIR/tools/check_strings.pl tr > $BASEDIR/doc/language_issues.tr
1979 $BASEDIR/tools/check_strings.pl it > $BASEDIR/doc/language_issues.it
1980 $BASEDIR/tools/check_langs.sh > $BASEDIR/doc/language_missings
1981 print_status DONE
1982
1983 echo -ne "Updating language lists..."
1984 update_language_list ${BASEDIR}/src/installer/po
1985 update_language_list ${BASEDIR}/src/setup/po
1986 print_status DONE
1987 ;;
1988 update-contributors)
1989 update_contributors
1990 ;;
1991 *)
1992 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain|update-contributors}"
1993 cat doc/make.sh-usage
1994 ;;
1995 esac